=== debian/changelog ===
pyperscan (0.2.2-0parrot1) lory; urgency=medium

  * Rebuild for Parrot 6.0.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Thu, 07 Sep 2023 02:20:31 +0200

pyperscan (0.2.2-0kali2) kali-experimental; urgency=medium

  * hyperscan doesn't compile on armhf and armel

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 26 May 2023 17:40:43 +0200

pyperscan (0.2.2-0kali1) kali-experimental; urgency=medium

  * Initial release.

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 16 May 2023 17:03:14 +0200
