=== debian/control ===
Source: pyperscan
Section: python
Priority: optional
Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 pybuild-plugin-pyproject,
 cargo,
 cmake,
 libboost-dev,
 librust-bindgen-dev,
 librust-bitflags-dev,
 librust-clap-3-dev,
 librust-cmake-dev,
 librust-env-logger-dev,
 librust-foreign-types-dev,
 librust-humantime-dev,
 librust-libloading-dev,
 librust-libc-dev,
 librust-pyo3-dev,
 librust-thiserror-dev,
 librust-which-dev,
 python3-pytest,
 python3-setuptools,
 python3-all,
 ragel,
 rustfmt,
 rustc (>= 1.64)
Testsuite: autopkgtest-pkg-python
Standards-Version: 4.6.2
Homepage: https://github.com/vlaci/pyperscan

Package: python3-pyperscan
Architecture: amd64 i386 arm64
Depends:
 ${python3:Depends},
 ${misc:Depends},
 ${shlibs:Depends},
Description: pyperscan Python module (Python 3)
 This package contains a Python module pyperscan.
 .
 This package installs the library for Python 3.
