## pyperscan 0.3.0

=== debian/changelog ===
pyperscan (0.3.0-0kali1) kali-dev; urgency=medium

  * New upstream version 0.3.0
  * Update debian/copyright
  * Refresh patches
  * Add missing build-deps
  * Use maturin to build and improve build
  * Run the upstream tests during the build

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 13 Mar 2024 10:17:40 +0100

pyperscan (0.2.2-0kali4) kali-dev; urgency=medium

  [ Sophie Brun ]
  * Disable CI build on unsupported arch (armel and armhf)

  [ Steev Klimaszewski ]
  * Bump bindgen dependency in patch to 0.66.1
  * Force gcc/g++-12 on arm64.
  * Prepare for Release

 -- Steev Klimaszewski <steev@kali.org>  Mon, 25 Sep 2023 14:57:30 -0500

pyperscan (0.2.2-0kali3) kali-dev; urgency=medium

  * Refresh patches: adapt pyo3 version for Kali

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 11 Aug 2023 12:09:17 +0200
