=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: pyperscan
 Section: python
 Priority: optional
-Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
-Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
+Maintainer: Kali Developers <devel@kali.org>
+Uploaders: Sophie Brun <sophie@offensive-security.com>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
@@ -10,7 +10,10 @@
  pybuild-plugin-pyproject,
  cargo,
  cmake,
+ gcc-12 [arm64],
+ g++-12 [arm64],
  libboost-dev,
+ libhyperscan-dev,
  librust-bindgen-dev,
  librust-bitflags-dev,
  librust-clap-3-dev,
@@ -23,6 +26,7 @@
  librust-pyo3-dev,
  librust-thiserror-dev,
  librust-which-dev,
+ python3-maturin,
  python3-pytest,
  python3-setuptools,
  python3-all,
@@ -32,6 +36,8 @@
 Testsuite: autopkgtest-pkg-python
 Standards-Version: 4.6.2
 Homepage: https://github.com/vlaci/pyperscan
+Vcs-Browser: https://gitlab.com/kalilinux/packages/pyperscan
+Vcs-Git: https://gitlab.com/kalilinux/packages/pyperscan.git
 
 Package: python3-pyperscan
 Architecture: amd64 i386 arm64
