=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/rustc/architecture.mk

export PYBUILD_NAME=pyperscan

export CARGO_HOME=$(CURDIR)/debian/cargo_home
export CARGO=/usr/share/cargo/bin/cargo
export DEB_CARGO_CRATE=$(DEB_SOURCE)_$(DEB_VERSION_UPSTREAM)

export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export DEB_HOST_RUST_TYPE DEB_HOST_GNU_TYPE

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

# arch detection is broken in gcc-13, so force 12 for now.
ifeq ($(DEB_HOST_ARCH),arm64)
export CC=gcc-12
export CXX=g++-12
endif


%:
	dh $@ --buildsystem=pybuild

execute_before_dh_auto_configure:
	$(CARGO) prepare-debian debian/cargo_registry --link-from-system
	rm -f Cargo.lock
